SystemOrganization addCategory: #'ByteSurgeon-MW'!
SystemOrganization addCategory: #'ByteSurgeon-Tests'!
SystemOrganization addCategory: #'ByteSurgeon-Compiler'!

RBValueNode subclass: #ByteSurgeonNode
	instanceVariableNames: 'reify operation tempOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!ByteSurgeonNode methodsFor: 'visitor' stamp: 'md 4/28/2005 14:42'!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptByteSurgeonNode: self! !

!ByteSurgeonNode methodsFor: 'testing' stamp: 'md 6/21/2005 13:50'!
isMeta
	^true.! !

!ByteSurgeonNode methodsFor: 'accessing' stamp: 'md 6/21/2005 13:49'!
reify
	^reify.! !

!ByteSurgeonNode methodsFor: 'accessing' stamp: 'md 4/28/2005 14:45'!
reify: aSelector
	reify:= aSelector.! !

!ByteSurgeonNode methodsFor: 'accessing' stamp: 'md 6/16/2005 14:19'!
tempOffset
	^IRInliner new getOffsetForName: reify.! !

Object subclass: #BCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

BCounter class
	instanceVariableNames: 'count'!

!BCounter commentStamp: '<historical>' prior: 0!
A simple counter with state in the class

  BCounter reset
  BCounter inc
  BCounter count!

!BCounter class methodsFor: 'as yet unclassified' stamp: 'md 2/10/2005 18:03'!
count
	^count.! !

!BCounter class methodsFor: 'as yet unclassified' stamp: 'md 2/22/2005 11:13'!
inc
	count := count + 1.! !

!BCounter class methodsFor: 'as yet unclassified' stamp: 'md 2/10/2005 18:03'!
reset
	count := 0.! !

Object subclass: #BSBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

!BSBenchmark class methodsFor: 'as yet unclassified' stamp: 'md 7/5/2005 14:38'!
bench
	^self new bench.! !

!BSBenchmark methodsFor: 'as yet unclassified' stamp: 'md 7/5/2005 14:43'!
bench
	| selectors tests |

	selectors := ByteSurgeonTest methodDict keys 
					select: [:each | each beginsWith: 'test' ]
					thenCollect: [:each | each asSymbol].

	tests := ByteSurgeonTest new.

	^ [selectors do: [:each | tests perform: each]] timeToRun.! !

Object subclass: #BSExamples
	instanceVariableNames: 't'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

!BSExamples commentStamp: '<historical>' prior: 0!
The TODO List for Bytesurgeon!

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 12:15'!
readContext: ctxt
	self assert: ctxt selector = #instAccess.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 11:39'!
readName: sel
	self assert: sel = 't'.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 11:54'!
readObject: sel
	self assert: sel class == self.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 12:01'!
readSelector: sel
	self assert: sel = #instAccess.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 12:19'!
readValue: val
	self assert: val = 1.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/20/2005 21:26'!
read: offset
	self assert: offset == 1.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/5/2005 12:10'!
sendBeforeOrAfter: sel args: args to: rec
	
	self assert: ( (sel = #squared) or: [  (sel = #returnParamWith:with:with:with:with:with:with:)]).

	sel = #returnParamWith:with:with:with:with:with:with: ifTrue: [
		self assert: (rec class = self).
		self assert: (args = #(1 2 3 4 5 6 7)).
		(args at: 7) timesRepeat: [BCounter inc].
	].

	sel = #squared ifTrue: [
		self assert: (rec class = SmallInteger).
		self assert: (args = #()).

		rec timesRepeat: [BCounter inc].
	].

	! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 14:23'!
sendContext: ctx
	self assert: ctx selector = #receiverArgs2.
	^3! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/13/2005 20:36'!
sendFrom: caller to: rec selector: sel withArgs: args
	
	self assert: sel = #returnParam:.
	self assert: caller class = self.
	self assert: (rec class = self).
	self assert: (args = #(1)).

	^rec perform: sel withArguments: args.! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/24/2005 11:15'!
sendResult: anObject
	self assert: anObject == 4.! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 14:24'!
sendSenderSelector: sel
	self assert: sel = #receiverArgs2.
	^3! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 14:15'!
sendSender: object
	self assert: object class = self.
	^3! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/5/2005 20:10'!
sendTo: receiver selector: sel
	
	self assert: ( (sel = #returnParam:and:) or: [  (sel = #returnParam:)]).

	sel = #returnParam:and: ifTrue: [
		self assert: (receiver class = self).
	].

	sel = #returnParam: ifTrue: [
		self assert: (receiver class = self).
		^1
	].! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/5/2005 20:06'!
sendWithArgs: args 
	
	self assert: (args = #(1 2)).
	^args inject: 0 into: [:sum :each | sum := sum + each. sum]! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/13/2005 15:54'!
sendWithSelector: sel
	
	self assert: sel = #returnParam:.
	^3
! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 3/2/2005 12:23'!
send: sel args: args to: rec
	
	self assert: ( (sel = #returnParam:and:) or: [  (sel = #returnParam:)]).

	sel = #returnParam:and: ifTrue: [
		self assert: (rec class = self).
		self assert: (args = #(1 2)).
	].

	sel = #returnParam: ifTrue: [
		self assert: (rec class = self).
		self assert: (args = #(1)).
	].
	^rec perform: sel withArguments: args.! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/3/2005 17:57'!
send: sel complexArgs: args to: rec
	
	self assert: (sel = #returnParamWith:and:and:).

	self assert: (rec class = self).
	self assert: (args class = Array).
	self assert: ((args at: 1) = 8).
	self assert: ((args at: 3) == Transcript).

	^rec perform: sel withArguments: args.! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/3/2005 14:54'!
send: sel manyArgs: args to: rec
	
	self assert: (sel = #returnParamWith:with:with:with:with:with:with:).

	self assert: (rec class = self).
	self assert: (args class = Array).
	self assert: (args = #(1 2 3 4 5 6 7)).

	^rec perform: sel withArguments: args.! !

!BSExamples methodsFor: 'example - bugs' stamp: 'md 7/9/2005 21:26'!
bug1
	self t: 3.! !

!BSExamples methodsFor: 'example - bugs' stamp: 'md 7/11/2005 15:06'!
bug2
	t := 1.
	self t: 1 + 3.
! !

!BSExamples methodsFor: 'example dispatch' stamp: 'md 6/27/2005 17:09'!
exampleDispatch
	^5+5

	"reification by hand"
	"MultiSend send: #'+' , ' to: 5 withArguments: 5."! !

!BSExamples methodsFor: 'examples' stamp: 'md 4/22/2005 16:42'!
instAccess
	t := 1.
	^t.! !

!BSExamples methodsFor: 'examples' stamp: 'md 3/2/2005 12:22'!
receiverArgs
	
	^self returnParam: 1.! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/5/2005 12:24'!
receiverArgs2
	| tmp1 tmp2 tmp3 |
	tmp1 := 1.
	tmp2 := 0.
	tmp3 := tmp1 + tmp2.
	^self returnParam: tmp3 and: (1 + 1).! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/3/2005 17:54'!
receiverComplexArgs
	
	^self returnParamWith: (2 raisedTo: 3) and: [17] and: Transcript.! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/3/2005 14:15'!
receiverManyArgs
	
	^self returnParamWith: 1 with: 2 with: 3 with: 4 with: 5 with: 6 with: 7.! !

!BSExamples methodsFor: 'examples' stamp: 'md 7/10/2005 22:52'!
return2Squared
	^2 squared         ! !

!BSExamples methodsFor: 'examples' stamp: 'md 3/4/2005 10:53'!
returnParamWith: aNumber and: aBlock and: globalVar
	
	self assert: (aNumber = 8).
	self assert: (aBlock value = 17).
	self assert: globalVar == Transcript.

	^aBlock value! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/3/2005 14:17'!
returnParamWith: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7
	
	^arg1 + arg2 + arg3 + arg4 + arg5 + arg6 + arg7! !

!BSExamples methodsFor: 'examples' stamp: 'dr 4/5/2005 20:18'!
returnParam: aParam
	| tt | 
	tt := 2 squared.
	tt := aParam.
	^tt! !

!BSExamples methodsFor: 'examples' stamp: 'md 3/2/2005 12:21'!
returnParam: aParam and: aSndParam
	^aParam + aSndParam.! !

!BSExamples methodsFor: 'examples' stamp: 'dr 6/7/2005 18:29'!
returnSimpleComputation
	| tmp |
	tmp := 2 raisedTo: 3.
	^tmp squared! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/5/2005 11:47'!
returnWithComplexSend
	| tt |
	tt := self returnParamWith: 1 with: 2 with: 3 with: 4 with: 5 with: 6 with: 7.
	^tt! !

!BSExamples methodsFor: 'as yet unclassified' stamp: 'md 7/10/2005 09:53'!
run
	^ 3 + 4! !

!BSExamples methodsFor: 'accessing' stamp: 'md 7/9/2005 21:25'!
t
	^t! !

!BSExamples methodsFor: 'examples' stamp: 'md 7/10/2005 09:15'!
tempAccess
	| tt |
	tt := 1.
	Object assert: true.
	^tt ! !

!BSExamples methodsFor: 'examples' stamp: 'md 11/26/2004 14:52'!
test: aParam
	^thisContext at: 1.! !

!BSExamples methodsFor: 'accessing' stamp: 'md 7/9/2005 21:25'!
t: anObject
	t := anObject.! !

Object subclass: #BSMethodWrapper
	instanceVariableNames: 'method class selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-MW'!

!BSMethodWrapper commentStamp: '<historical>' prior: 0!
I provide the features of MethodWrapers, but implemented by Inlining the Before/After methods

In before/after methods implemented in the Wrapper class can be called ("self something"), but
direkt instVar access should not be used. (Will not work as it would try to access instVars
of the wrappee, not the wrapper).

This does not yet wrap method in ensure block for after.



TestMethodWrapperCounter allInstances do: [:i | SystemChangeNotifier uniqueInstance noMoreNotificationsFor: i]
!

!BSMethodWrapper class methodsFor: 'instance creation' stamp: 'md 2/26/2005 16:27'!
on: aSelector inClass: aClass
	^self new class: aClass selector: aSelector.
	! !

!BSMethodWrapper methodsFor: 'before after' stamp: 'md 2/22/2005 13:35'!
afterMethod! !

!BSMethodWrapper methodsFor: 'before after' stamp: 'md 2/22/2005 13:35'!
beforeMethod! !

!BSMethodWrapper methodsFor: 'accessing' stamp: 'md 2/23/2005 12:24'!
class: aClass selector: aSelector
	class := aClass.
	selector := aSelector.! !

!BSMethodWrapper methodsFor: 'private' stamp: 'md 6/11/2005 15:30'!
inlineBeforeAfter
	"install the wrapper by inlining before/after"
	|  before after |

	before := (self class lookupSelector: #beforeMethod) ir instructionsForInlining.
	after := (self class lookupSelector: #afterMethod) ir instructionsForInlining.
	
	before := self replaceSelf: before.
	after := self replaceSelf: after.
	self method insertBefore: before after: after.! !

!BSMethodWrapper methodsFor: 'installing' stamp: 'md 2/26/2005 16:24'!
install
	"install the wrapper"
	self inlineBeforeAfter.
	self registerNotification.! !

!BSMethodWrapper methodsFor: 'accessing' stamp: 'md 2/23/2005 11:41'!
method
	^class>>selector.! !

!BSMethodWrapper methodsFor: 'change notification' stamp: 'md 2/26/2005 16:24'!
methodModified: aMethodChange
	(class = (aMethodChange environmentAt: #class)) ifFalse: [^self].
	(selector = (aMethodChange environmentAt: #selector)) ifFalse: [^self].
	self inlineBeforeAfter.! !

!BSMethodWrapper methodsFor: 'change notification' stamp: 'md 2/23/2005 11:15'!
registerNotification
	SystemChangeNotifier uniqueInstance
			notify: self
			ofSystemChangesOfItem: #method 
			change: #Modified 
			using: #methodModified:.! !

!BSMethodWrapper methodsFor: 'private' stamp: 'md 7/10/2005 09:14'!
replaceSelf: ir
	"replace self with pointer to me"
	^ ir collect: [:instr | instr isSelf ifTrue: [IRInstruction pushLiteral: self] ifFalse: [instr]]
! !

!BSMethodWrapper methodsFor: 'installing' stamp: 'md 2/26/2005 16:24'!
uninstall
	"remove the wrapper by deregistering from change
      notification and recompiling... "
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self.
	self method recompile.! !

BSMethodWrapper subclass: #TestMethodWrapperCounter
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-MW'!

!TestMethodWrapperCounter commentStamp: '<historical>' prior: 0!
A simple Wrapper that has state (a counter) as an instvar of the wrapper. !

!TestMethodWrapperCounter methodsFor: 'wrapper' stamp: 'md 2/24/2005 11:07'!
beforeMethod
	self inc.! !

!TestMethodWrapperCounter methodsFor: 'accessing' stamp: 'md 2/22/2005 15:15'!
counter 
	^counter.! !

!TestMethodWrapperCounter methodsFor: 'counter' stamp: 'md 2/24/2005 11:08'!
inc
	counter := counter + 1.! !

!TestMethodWrapperCounter methodsFor: 'initialize-release' stamp: 'md 2/22/2005 15:44'!
initialize
	self reset.! !

!TestMethodWrapperCounter methodsFor: 'counter' stamp: 'md 2/22/2005 15:44'!
reset
	counter := 0.! !

BSMethodWrapper subclass: #TestMethodWrapperSimple
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-MW'!

!TestMethodWrapperSimple commentStamp: '<historical>' prior: 0!
A simple example for MethodWrappers: Use BCounter to count entry/exit.!

!TestMethodWrapperSimple methodsFor: 'before after' stamp: 'md 2/22/2005 14:27'!
afterMethod
	BCounter inc.! !

!TestMethodWrapperSimple methodsFor: 'before after' stamp: 'md 2/22/2005 14:26'!
beforeMethod
	BCounter inc.! !

Object subclass: #BSTodo
	instanceVariableNames: 't'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

!BSTodo commentStamp: '<historical>' prior: 0!
The TODO for Bytesurgeon!

!BSTodo methodsFor: 'Bytesurgeon' stamp: 'md 4/25/2005 15:53'!
ensureWrapping
'

For ensure wrapping:

-> use splitAfter to get second sequence.

wrapInEnsureBlock: aMethod with: statements

	| seq  |

	seq := ir startSequence nextSequence splitAfter: (IRInstruction send: #squared) .
	
	blockSeq add: IRInstruction blockReturnTop.

	seq add: (IRInstruction pushTemp: -2);  
		add: (IRInstruction pushLiteral: 0);
		add: (IRInstruction send: #blockCopy:);
		add: ((IRJumpOverBlock new) 
				destination: destSeq     ;
				blockSequence: blockSeq ;
				yourself).		
	
	aMethod startSequence: seq.	"
			'

! !

!BSTodo methodsFor: 'Bytesurgeon' stamp: 'md 5/3/2005 15:53'!
subjectivity
'


Idea Subjectivity: Search Stack one, then add Flag.



'! !

!BSTodo methodsFor: 'Bytesurgeon' stamp: 'md 7/10/2005 23:24'!
todo
' 
 - IRBuilder / IRMethod: properties interface like CompiledMethod.
 - Store Variable implementieren bytecode
 - Decompiler variable store
 - Add support for globals to BS
 - Implement mechanism for $proceed.
 - balanceStack with StackAnalyzer
 - regressiontests: tinyBenchmarks with BS.
 
Version 2:
  - inline blocks --> need to get IR for OldStyle Blocks.
  - Ensure Wrapping.
  - Variable access in inlined code
  - Fix Compiler IR-->RBNode decompile

Questions:

  - Hook auf hook? --> Do we need to know where hooks are?

Optimizations:
----------------

Runtime:
 - Sends: the number of sends is fixed-->we can use a litereal array
CompileTime:
 - IRSequence: use collection, not LinkedList

'! !

!Object methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 15:00'!
instVarNameForOffset: offset
	^self class instVarNameForOffset: offset.! !

!RBProgramNodeVisitor methodsFor: '*ByteSurgeon' stamp: 'md 4/28/2005 15:47'!
acceptByteSurgeonNode: aNode
	! !

!RBProgramNode methodsFor: '*byteSurgeon' stamp: 'md 6/21/2005 13:50'!
isMeta
	^false.! !

TestCase subclass: #BSMethodWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-MW'!

!BSMethodWrapperTest methodsFor: 'testing' stamp: 'md 7/10/2005 09:36'!
testMethodWrapper
	|w|
	BCounter reset. BSExamples compileAll.

	w := TestMethodWrapperSimple on: #tempAccess inClass: BSExamples.
	w install.

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 6).
 
	BCounter reset. w uninstall.
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 0).
! !

!BSMethodWrapperTest methodsFor: 'testing' stamp: 'md 7/10/2005 09:45'!
testMethodWrapperWithState
	
	|w|

	BCounter reset.
	BSExamples compileAll.

	w := TestMethodWrapperCounter on: #tempAccess inClass: BSExamples.
	w install.

	self assert: (w counter = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (w counter = 3).

	w uninstall. w reset.
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (w counter = 0).
! !

TestCase subclass: #ByteSurgeonTest
	instanceVariableNames: 't'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

ByteSurgeonTest class
	instanceVariableNames: 'rem'!

!ByteSurgeonTest commentStamp: '<historical>' prior: 0!
These are some tests for Bytesurgeon.!

!ByteSurgeonTest class methodsFor: 'as yet unclassified' stamp: 'md 6/24/2005 16:05'!
recompile: sel

	BSExamples recompile: sel.! !

!ByteSurgeonTest class methodsFor: 'as yet unclassified' stamp: 'md 2/10/2005 18:24'!
rem
	^rem.! !

!ByteSurgeonTest class methodsFor: 'as yet unclassified' stamp: 'md 2/10/2005 18:24'!
rem: anObject
	rem := anObject.! !

!ByteSurgeonTest methodsFor: 'tools' stamp: 'md 6/24/2005 16:14'!
recompile: sel

	BSExamples recompile: sel.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:19'!
testAccessAdditionalVars

	| vars |
	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	vars := Dictionary newFrom: {#hello -> 20}.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertAfter: 'self assert: <meta: #hello> = 20' with: vars.
	].
	BSExamples new instAccess.
	self recompile: #instAccess.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:12'!
testAddAfterInstVarRead
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertAfter: 'BCounter inc'.
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:14'!
testAddAfterInstVarStore
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr insertAfter: 'BCounter inc'.
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:14'!
testAddBeforeInstVarRead
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertBefore: 'BCounter inc'.
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 7/1/2005 11:30'!
testAddBeforeInstVarStore
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr replaceAndStore: '2'.
	].

	self assert: (BSExamples new instAccess = 2).

	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:15'!
testAddBeforInstVarStoreSpecialVarNewValue

	self recompile: #instAccess.

	self assert: (BSExamples new instAccess = 1).


	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr insertBefore: 'self assert: (<meta: #newvalue> = 1).'
	].

	self assert: (BSExamples new instAccess=1).


	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:11'!
testAddCodeAfterSend

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | send insertAfter: 'BCounter inc'].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:20'!
testAddCodeAfterSendAdditonalVar
	| vars |
	self recompile: #return2Squared.	
	vars := Dictionary newFrom: {#hello -> 20}.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
			send insertAfter: 'self assert: <meta: #hello> = 20' with: vars
	].
	BSExamples new return2Squared.
	self recompile: #return2Squared.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:11'!
testAddCodeAfterSendComplex

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
				send insertAfter: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:09'!
testAddCodeBeforeSend
	"same, just use #addbefore:"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | send insertBefore: 'BCounter inc'].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:07'!
testAddCodeBeforeSendComplex
	"same, just use #addbefore:"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send |
			send insertBefore: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:15'!
testAddCodeReplaceSendComplex
	"same, just use #addbefore:"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
			send replace: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:07'!
testAfterComplexExpression2
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
			const insertAfter: '(1< 2) ifTrue: [(1<2) ifTrue: [Transcript show: ''constant'']].'.
	].
	self assert: 	BSExamples new return2Squared = 4.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/24/2005 16:06'!
testAfterMethod

	BCounter reset.
	self recompile: #return2Squared.

    (BSExamples>>#return2Squared) insertAfter: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:21'!
testAfterMethodAdditionalVar

	| vars |
	self recompile: #return2Squared.
	vars := Dictionary newFrom: {#hello -> 20}.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
			send insertAfter: 'self assert: <meta: #hello> = 20' with: vars
	].
	BSExamples new return2Squared.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:21'!
testAfterMethodArg7and3

	self recompile: #returnParamWith:with:with:with:with:with:with:.

	(BSExamples>>#returnParamWith:with:with:with:with:with:with:) insertBefore: 
				'self assert: (<meta: #arg7> = 7). self assert: (<meta: #arg3> = 3)'.

	BSExamples new receiverManyArgs.
	
	self recompile: #returnParamWith:with:with:with:with:with:with:.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:21'!
testAfterMethodArgs

	self recompile: #returnParamWith:with:with:with:with:with:with:.

	(BSExamples>>#returnParamWith:with:with:with:with:with:with:) insertBefore: 
				'self assert: (<meta: #arguments> size = 7) '.

	BSExamples new receiverManyArgs.
	
	self recompile: #returnParamWith:with:with:with:with:with:with:.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:21'!
testAfterMethodVarContext

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertAfter: 'BCounter inc. self assert: thisContext class= MethodContext '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:21'!
testAfterMethodVarResult

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertAfter: 'BCounter inc. self assert: <meta: #result> = 4 '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:20'!
testAfterSpecialVarArg1

	self recompile: #receiverArgs.

	(BSExamples>>#receiverArgs) instrumentSend: [:send | 
			send replace: 'self assert: <meta: #arg1> = 1'
	].

	BSExamples new receiverArgs.
	self recompile: #receiverArgs.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:20'!
testAfterSpecialVarArg2

	self recompile: #receiverArgs2.

	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
		(send selector = #returnParam:and:) ifTrue: [
				send replace: 'self assert: <meta: #arg2> = 2'
		]
	].

	BSExamples new receiverArgs2.
	
	self recompile: #receiverArgs2.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:20'!
testAfterSpecialVarArg7

	self recompile: #receiverManyArgs.

	(BSExamples>>#receiverManyArgs) instrumentSend: [:send | 
			send replace: 'self assert: <meta: #arg7> = 7'
	].

	BSExamples new receiverManyArgs.
	
	self recompile: #receiverManyArgs.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:20'!
testAfterSpecialVarArg7and3

	self recompile: #receiverManyArgs.

	(BSExamples>>#receiverManyArgs) instrumentSend: [:send | 
		send replace: 'self assert: <meta: #arg7> = 7. self assert: <meta: #arg3> = 3'
	].

	BSExamples new receiverManyArgs.	
	self recompile: #receiverManyArgs.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:21'!
testAfterSpecialVarArgReceiver

	self recompile: #receiverArgs2.

	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'self assert: <meta: #arg2> = 2. self assert: <meta: #receiver> class = BSExamples'.
			]
	].

	BSExamples new receiverArgs2.
	
	self recompile: #receiverArgs2.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:21'!
testAfterSpecialVarArgs

	self recompile: #receiverArgs2.

	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
		(send selector = #returnParam:and:) ifTrue: [
			send insertAfter: 'self assert: <meta: #arguments> = #(1 2)'.
		]
	].

	BSExamples new receiverArgs2.
	self recompile: #receiverArgs2.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:22'!
testAfterSpecialVarResult

	self recompile: #returnParam:.

	(BSExamples>>#returnParam:) instrumentSend: [:send | 
			send insertAfter: 'BSExamples sendResult: <meta: #result>'.
	].

	self assert: (BSExamples new returnParam: 2) = 2.
	
	self recompile: #returnParam:.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testAfterSpecialVars
	"Test sending a msg to a metaobject after a base-level send"

	BCounter reset.
	self recompile: #returnParam:.

	(BSExamples>>#returnParam:) instrumentSend: [:send | 
			send insertAfter: 'BSExamples sendBeforeOrAfter:', send selector printString, ' args: <meta: #arguments> to: <meta: #receiver>'.
	].

	self assert: (BCounter count = 0).
	self assert: (BSExamples new returnParam: 2) = 2.
	self assert: (BCounter count = 2).

	BCounter reset.
	self recompile: #returnParam:.
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testAfterSpecialVars2
	"Test sending a msg to a metaobject after a base-level send"

	BCounter reset.
	self recompile: #returnWithComplexSend.

	(BSExamples>>#returnWithComplexSend) instrumentSend: [:send | 
			send insertAfter: 'BSExamples sendBeforeOrAfter:', send selector printString,' args: <meta: #arguments> to: <meta: #receiver>'.
	].

	self assert: (BCounter count = 0).
	self assert: (BSExamples new returnWithComplexSend) = 28.
	self assert: (BCounter count = 7).

	BCounter reset.
	self recompile: #returnWithComplexSend.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/24/2005 16:13'!
testBeforeMethod

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/24/2005 16:15'!
testBeforeMethodComplex

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:22'!
testBeforeMethodTrueFalse

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'self assert: true = false not'.

	3 timesRepeat: [BSExamples new return2Squared].

	
	self recompile: #return2Squared.
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:22'!
testBeforeMethodVarContext

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: thisContext class = MethodContext  '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:23'!
testBeforeMethodVarReceiver

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: <meta: #receiver> class == BSExamples '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:17'!
testBeforeMethodVarSelector

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc.  self assert: thisContext selector = #return2Squared  '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:23'!
testBeforeMethodVarSelf

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: self class == BSExamples '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:17'!
testBeforeMethodVarSender

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: <meta: #sender> class == ByteSurgeonTest '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/30/2005 15:03'!
testBeforeMethodVarSenderContext

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: (<meta: #senderContext> isKindOf: ContextPart)  '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testBeforeSpecialVars
	"Test sending a msg to a metaobject after a base-level send"

	BCounter reset.
	self recompile: #returnParam:.

	(BSExamples>>#returnParam:) instrumentSend: [:send | 
			send insertBefore: 'BSExamples sendBeforeOrAfter:', send selector printString,' args: <meta: #arguments> to: <meta: #receiver>'.
	].

	self assert: (BCounter count = 0).
	self assert: (BSExamples new returnParam: 2) = 2.
	self assert: (BCounter count = 2).

	BCounter reset.
	self recompile: #returnParam:.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testBeforeSpecialVars2
	"Test sending a msg to a metaobject after a base-level send"

	BCounter reset.
	self recompile: #returnWithComplexSend.

	(BSExamples>>#returnWithComplexSend) instrumentSend: [:send | 
			send insertBefore: 'BSExamples sendBeforeOrAfter:', send selector printString,' args: <meta: #arguments> to: <meta: #receiver>'.
	].

	self assert: (BCounter count = 0).
	self assert: (BSExamples new returnWithComplexSend) = 28.
	self assert: (BCounter count = 7).

	BCounter reset.
	self recompile: #returnWithComplexSend.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 7/9/2005 21:29'!
testBug1
	"test written for bugreport:
	Von: 	  hawkie@bluewin.ch
	Betreff: 	bytesurgeon fehler?
	Datum: 	4. Juli 2005 20:14:31 GMT+02:00
	An: 	  denker@iam.unibe.ch"


	self recompile: #bug1.

	(BSExamples>>#bug1) instrumentSend: [:send | send insertBefore: 'BCounter inc' ].
	
	BSExamples new bug1.
	self recompile: #bug1.

	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:14'!
testCountInstVarAccess

	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarAccess: [:instr | 
		instr insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 6).

	BCounter reset.
	self recompile: #instAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:15'!
testCountInstVarRead

	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertAfter: 'BCounter inc'
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:11'!
testCountInstVarWrite

	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:13'!
testCountSends

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
			send insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempValue

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
			temp insertAfter: 'self assert: (<meta: #value> = nil)'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:14'!
testCountTempVarAccess

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempAccess: [:temp | 
		temp insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 6).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:13'!
testCountTempVarComplexAfter

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:10'!
testCountTempVarComplexBefore

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertBefore: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:10'!
testCountTempVarComplexReplace

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp replace: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new tempAccess].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempVarName

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempAccess: [:temp | 
		temp insertAfter: 'self assert: ', temp varname printString, ' = ''tt'''.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempVarNewValue

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: 'self assert: (<meta: #newvalue> = 1)'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempVarOffset

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: 'self assert: ', temp offset printString, ' = 1'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:16'!
testCountTempVarRead

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempRead: [:temp | 
		temp insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempVarSelector

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: 'self assert: (', temp selector printString, ' = #tempAccess)'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:23'!
testCountTempVarSelf
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: 'self assert: (self class = BSExamples)'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:12'!
testCountTempVarWrite

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
			temp insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'examples - paper' stamp: 'md 6/27/2005 16:35'!
testEx43

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
		send selector = #squared ifTrue: [send selector: #negated ] ].

	self assert: (BSExamples new return2Squared = -2).
	self recompile: #return2Squared.
	! !

!ByteSurgeonTest methodsFor: 'examples - paper' stamp: 'md 6/27/2005 16:35'!
testEx43b

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
		send selector = #squared ifTrue: [send replace: {IRInstruction send: #negated}]. 
 	].

	self assert: (BSExamples new return2Squared = -2).
	self recompile: #return2Squared.
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:14'!
testExampleComplexExpression
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
			const insertBefore: '(1< 2) ifTrue: [Transcript show: ''constant''].'.
	].
	self assert: 	BSExamples new return2Squared = 4.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:16'!
testExampleComplexExpression2
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
			const insertBefore: '(1< 2) ifTrue: [(1<2) ifTrue: [Transcript show: ''constant'']].'
	].
	self assert: 	BSExamples new return2Squared = 4.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:09'!
testExampleTranscript
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
		const insertBefore: 'Transcript show: ''constant'''.
	].
	self assert: 	BSExamples new return2Squared = 4.

	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/30/2005 17:10'!
testInstrumentAll
	| aBlockCollection |

	BCounter reset.
	self recompile: #instAccess.

	aBlockCollection := {
		[:instr | instr isInstVarRead ifTrue: [instr insertAfter: 'BCounter inc']].
		[:instr | instr isInstVarStore ifTrue: [instr insertAfter: 'BCounter inc']]
	}.

	(BSExamples>>#instAccess) instrumentAll: aBlockCollection.
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 6).

	BCounter reset.
	self recompile: #instAccess.
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:12'!
testInstrumentClass

	self assert: BSExamples new return2Squared = 4.

	BSExamples instrumentConstant: [:const | 
		const constant: 3.
	].

	self assert: BSExamples new return2Squared = 9.
	BSExamples compileAll.
	self assert: BSExamples new return2Squared = 4.! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:13'!
testInstrumentMethod

	self recompile: #return2Squared.
	self assert: BSExamples new return2Squared = 4.

	(BSExamples>>#return2Squared) instrumentConstant: [:const | 
		const constant: 3.
	].

	self assert: BSExamples new return2Squared = 9.
	self recompile: #return2Squared.
	self assert: BSExamples new return2Squared = 4.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:09'!
testInstVarAfterComplex
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertAfter: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:13'!
testInstVarBeforeComplex
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertBefore: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].
	
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:10'!
testInstVarReplaceComplex
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].
	
	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new instAccess].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:14'!
testReplace

	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentConstant: [:const | 
		const replace: '5'.
	].

	self assert: (BSExamples new return2Squared = 25).
	self recompile: #return2Squared.
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:15'!
testReplaceComplexExpression2
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
		const replace: '(1< 2) ifTrue: [(1<2) ifTrue: [3]].'
	].
	self assert: 	BSExamples new return2Squared = 9.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:08'!
testReplaceInstVarRead

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | instr replace: '5'].

	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarName

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples readName: ', instr varname printString.
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarOffset

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples read: ', instr offset printString.
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarSelector

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples readSelector: ', instr selector printString .
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarSelf

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples readObject: self'.
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarValue

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples readValue: <meta: #value>'.
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:13'!
testReplaceInstVarStore

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr |  instr replace: '5'].

	self assert: (BSExamples new instAccess = nil).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:20'!
testReplaceInstVarStoreSpecialVarNewvalue

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr replace: 'self assert: <meta: #newvalue> = 1'.
	].
	self assert: (BSExamples new instAccess = nil).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:20'!
testReplaceInstVarStoreSpecialVarValue

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr replace: 'self assert: <meta: #value> = nil'.
	].
	self assert: (BSExamples new instAccess = nil).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/24/2005 16:14'!
testReplaceMethod

	self recompile: #return2Squared.
	(BSExamples>>#return2Squared) replace: '^thisContext class'.
	self assert: (BSExamples new return2Squared = MethodContext).
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/24/2005 16:12'!
testReplaceMethodComplex

	self recompile: #return2Squared.
	(BSExamples>>#return2Squared) replace: '(1<2) ifTrue: [(1<2) ifTrue: [^thisContext class]]'.
	self assert: (BSExamples new return2Squared = MethodContext).
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVars

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'BSExamples sendWithArgs: <meta: #arguments>'
		]
	]. 
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVars2

	self recompile: #receiverArgs.
	(BSExamples>>#receiverArgs) instrumentSend: [:send | 
				send replace: 'BSExamples sendTo: <meta: #receiver> selector: ',send selector printString.
	]. 
	self assert: (BSExamples new receiverArgs = 1).
	self recompile: #receiverArgs.
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVarsContext

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'BSExamples sendContext: thisContext'
			]
	]. 
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVarsSelf

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'BSExamples sendSender: self'
			]
	]. 
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVarsSender

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'BSExamples sendSender: <meta: #sender>'
			]
	]. 
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/30/2005 14:52'!
testReplaceSomeSpecialVarsSenderContext

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'self assert: (<meta: #senderContext> class = MethodContext) '
				
			]
	]. 
	BSExamples new receiverArgs2.
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSpecialVars

	self recompile: #receiverArgs.
	(BSExamples>>#receiverArgs) instrumentSend: [:send | 
				send replace: 'BSExamples send:', send selector printString, ' args: <meta: #arguments> to: <meta: #receiver>'
	]. 
	self assert: (BSExamples new receiverArgs = 1).
	self recompile: #receiverArgs.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSpecialVars2

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send evaluate: [:i | i selector = #returnParam:and:]) ifTrue: [
				send replace: 'BSExamples send:', send selector printString,' args: <meta: #arguments> to: <meta: #receiver>'
			]
	].
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSpecialVarsComplexArgs

	self recompile: #receiverComplexArgs.
	(BSExamples>>#receiverComplexArgs) instrumentSend: [:send | 
			(send selector = #returnParamWith:and:and:) ifTrue: [
				send replace: 'BSExamples send:', send selector printString, ' complexArgs: <meta: #arguments> to: <meta: #receiver>'
		]
	].
	self assert: (BSExamples new receiverComplexArgs = 17).
	self recompile: #receiverComplexArgs.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSpecialVarsManyArgs

	self recompile: #receiverManyArgs.
	(BSExamples>>#receiverManyArgs) instrumentSend: [:send | 
			 send selector = #returnParamWith:with:with:with:with:with:with: ifTrue: [
				send replace: 'BSExamples send: ', send selector printString, ' manyArgs: <meta: #arguments> to: <meta: #receiver>'
			]
	].
	self assert: (BSExamples new receiverManyArgs = 28).
	self recompile: #receiverManyArgs.

	! !

SqueakParser subclass: #ByteSurgeonParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!ByteSurgeonParser commentStamp: '<historical>' prior: 0!
Modified Parser for Bytesurgeon: This adds support for <ARGS: aNumber> access to unamed arguments!

!ByteSurgeonParser class methodsFor: 'generated-comments' stamp: 'md 6/11/2005 14:51'!
parserDefinitionComment

	"%id <name> <number> <negativeNumber> <binarySymbol> <period>;
%start Sequence MethodPattern;

Method:
	MethodPattern Sequence						{#method:}
|	MethodPattern Primitive Sequence			{#methodPrim:}
|	MethodPattern Temporaries Primitive Statements {#methodTempsPrim:};

MethodPattern:
	<name>										{#unaryMessage:}
|	<binarySymbol> Variable						{#messagePart:}
|	KeywordMethodPattern						{#first:};

KeywordMethodPattern:
	<keyword> Variable							{#messagePart:}
|	KeywordMethodPattern <keyword> Variable	{#addMessagePart:};

Primitive:
	""<"" PrimitiveMessage "">""						{#primitiveMessage:};

Sequence:
	Statements									{#sequence:}
|	Temporaries Statements						{#sequenceWithTemps:};

Temporaries:
	""||""											{#array}
|	""|"" TemporaryVariables ""|""					{#second:};

TemporaryVariables:
												{#array}
|	TemporaryVariables Variable				{#add:};

Statements:
												{#array}
|	StatementList <period>?						{#first:}
|	StatementList <period> ""^"" Expression <period>?	{#returnAdd:}
|	""^"" Expression <period>?						{#return:};

StatementList:
	Expression									{#firstIn:}
|	StatementList <period> Expression				{#add3:};

Block:
	""["" BlockArgs ""|"" Sequence ""]""					{#blockWithArgs:}
|	""["" Sequence ""]""								{#blockNoArgs:}
|	""["" BlockArgs ""]""								{#blockArgs:}
|	""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"" {#blockWithTemps:};

BlockArgs:
	"":"" Variable									{#secondIn:}
|	BlockArgs "":"" Variable						{#add3:};

Expression:
	Assignment									{#first:}
|	Cascade										{#first:}
|	Primary									{#first:};

Primary:
	""("" Expression "")""								{#second:}
|	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Assignment:
	Variable <assignment> Expression				{#assignment:};

Cascade:
	MessageSend								{#first:}
|	Cascade "";"" Message							{#cascade:};

MessageSend:
	KeywordMessageSend						{#first:}
|	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:};

Message:
	UnaryMessage								{#first:}
|	BinaryMessage								{#first:}
|	KeywordMessage							{#first:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage			{#messageSend:}
|	UnaryMessageSend KeywordMessage			{#messageSend:}
|	Primary KeywordMessage					{#messageSend:};

KeywordMessage:
	<keyword> KeywordArgument				{#messagePart:}
|	KeywordMessage <keyword> KeywordArgument {#addMessagePart:};

KeywordArgument:
	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:}
|	Primary									{#first:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage			{#messageSend:}
|	UnaryMessageSend BinaryMessage			{#messageSend:}
|	Primary BinaryMessage						{#messageSend:};

BinaryMessage :
	<binarySymbol> BinaryArgument				{#messagePart:};

BinaryArgument:
	UnaryMessageSend							{#first:}
|	Primary									{#first:};

UnaryMessageSend :
	UnaryMessageSend UnaryMessage			{#messageSend:}
|	Primary UnaryMessage						{#messageSend:};

UnaryMessage :
	<name>										{#unaryMessage:};

Array:
	""{"" Statements ""}""								{#array:};

Variable: 
	<name>										{#variable:};

Literal:
	""true""										{#litTrue:}
|	""false""										{#litFalse:}
|	""nil""										{#litNil:}
|	<number>									{#litNumber:}
|	<negativeNumber>							{#litNumber:} 
|	<character>									{#litChar:}
|	<string>										{#litString:}
|	""#"" <string>									{#litStringSymbol:}
|	""#"" <name>									{#litSymbol:}
|	""#"" <binarySymbol>							{#litSymbol:}
|	""#"" <keyword>								{#litSymbol:}
|	""#"" <multikeyword>							{#litSymbol:}
|	""#"" <alternateKeyword>						{#litSymbol:}
|	""#"" ""["" ByteArray ""]""							{#litArray:}
|	""#"" ""("" LiteralArray "")""						{#litArray:}
|	""#:""											{#litString:}
|     ""<meta:"" ""#""<name>  "">""						{#bsMeta:};



ByteArray:
												{#byteStream}
|	ByteArray <number>							{#byteStreamPut:};

LiteralArray:
												{#stream}
|	LiteralArray ArrayLiteral					{#streamPut:};

ArrayLiteral:
	Literal										{#value:}
|	<name>										{#valueSymbol:}
|	<binarySymbol>								{#valueSymbol:}
|	<keyword>									{#valueSymbol:}
|	<multikeyword>								{#valueSymbol:}
|	<alternateKeyword>							{#valueSymbol:}
|	""("" LiteralArray "")""							{#contents2:}
|	""["" ByteArray ""]""							{#contents2:}
|	<anyChar>									{#valueSymbol:};

PrimitiveMessage:
	| PrimitiveMessage <keyword>
	| PrimitiveMessage Literal
	| PrimitiveMessage ""(""
	| PrimitiveMessage "")""
	| PrimitiveMessage ""{""
	| PrimitiveMessage ""}""
	| PrimitiveMessage "";""
	| PrimitiveMessage <period>
	| PrimitiveMessage <name>
	| PrimitiveMessage <binarySymbol>;
"! !

!ByteSurgeonParser class methodsFor: 'bytesurgeon' stamp: 'md 6/29/2005 13:57'!
parseStringForInlining: aString

	^self parseStringForInlining: aString inliner: nil.! !

!ByteSurgeonParser class methodsFor: 'bytesurgeon' stamp: 'md 6/29/2005 15:22'!
parseStringForInlining: aString inliner: anInliner

	| ir  |
	ir := (self parseDoIt: aString) generateIRForInlining: anInliner.
	^ ir removeReturn removeEmptyStart startSequence.! !

!ByteSurgeonParser class methodsFor: 'generated-accessing' stamp: 'md 6/11/2005 14:51'!
scannerClass
	^ByteSurgeonScanner! !

!ByteSurgeonParser class methodsFor: 'generated-starting states' stamp: 'md 6/11/2005 14:51'!
startingStateForMethod
	^1! !

!ByteSurgeonParser class methodsFor: 'generated-starting states' stamp: 'md 6/11/2005 14:51'!
startingStateForMethodPattern
	^3! !

!ByteSurgeonParser class methodsFor: 'generated-starting states' stamp: 'md 6/11/2005 14:51'!
startingStateForSequence
	^2! !

!ByteSurgeonParser methodsFor: 'reduction actions' stamp: 'md 6/10/2005 15:09'!
bsMeta: node
	^ByteSurgeonNode new 
				reify: node third value asSymbol.! !

!ByteSurgeonParser methodsFor: 'generated-reduction actions' stamp: 'md 6/11/2005 14:51'!
reduceActionForOptionalXXXperiodX1: nodes 
	^ nil! !

!ByteSurgeonParser methodsFor: 'generated-reduction actions' stamp: 'md 6/11/2005 14:51'!
reduceActionForOptionalXXXperiodX2: nodes 
	^ nodes at: 1! !

!ByteSurgeonParser methodsFor: 'generated-tables' stamp: 'md 6/11/2005 14:51'!
reduceTable
	^#(
#(35 0 #array)
#(35 2 #first:)
#(35 5 #returnAdd:)
#(35 3 #return:)
#(36 0 #array)
#(36 2 #add:)
#(37 1 #firstIn:)
#(37 3 #add3:)
#(38 0 #reduceActionForOptionalXXXperiodX1:)
#(38 1 #reduceActionForOptionalXXXperiodX2:)
#(39 1 #first:)
#(39 1 #first:)
#(39 1 #first:)
#(40 2 #secondIn:)
#(40 3 #add3:)
#(41 5 #blockWithArgs:)
#(41 3 #blockNoArgs:)
#(41 3 #blockArgs:)
#(41 7 #blockWithTemps:)
#(42 3 #assignment:)
#(43 1 #first:)
#(43 3 #cascade:)
#(44 3 #second:)
#(44 1 #first:)
#(44 1 #first:)
#(44 1 #first:)
#(44 1 #first:)
#(45 3 #array:)
#(46 1 #litTrue:)
#(46 1 #litFalse:)
#(46 1 #litNil:)
#(46 1 #litNumber:)
#(46 1 #litNumber:)
#(46 1 #litChar:)
#(46 1 #litString:)
#(46 2 #litStringSymbol:)
#(46 2 #litSymbol:)
#(46 2 #litSymbol:)
#(46 2 #litSymbol:)
#(46 2 #litSymbol:)
#(46 2 #litSymbol:)
#(46 4 #litArray:)
#(46 4 #litArray:)
#(46 1 #litString:)
#(46 4 #bsMeta:)
#(47 1 #array)
#(47 3 #second:)
#(48 1 #first:)
#(48 1 #first:)
#(48 1 #first:)
#(49 2 #messagePart:)
#(49 3 #addMessagePart:)
#(50 2 #messageSend:)
#(50 2 #messageSend:)
#(50 2 #messageSend:)
#(51 2 #messageSend:)
#(51 2 #messageSend:)
#(51 2 #messageSend:)
#(52 2 #messageSend:)
#(52 2 #messageSend:)
#(53 1 #unaryMessage:)
#(54 2 #messagePart:)
#(55 2 #messagePart:)
#(55 3 #addMessagePart:)
#(56 1 #first:)
#(56 1 #first:)
#(56 1 #first:)
#(57 1 #first:)
#(57 1 #first:)
#(58 1 #variable:)
#(59 3 #primitiveMessage:)
#(60 1 #unaryMessage:)
#(60 2 #messagePart:)
#(60 1 #first:)
#(61 1 #sequence:)
#(61 2 #sequenceWithTemps:)
#(62 0 #byteStream)
#(62 2 #byteStreamPut:)
#(63 0 #stream)
#(63 2 #streamPut:)
#(64 1 #value:)
#(64 1 #valueSymbol:)
#(64 1 #valueSymbol:)
#(64 1 #valueSymbol:)
#(64 1 #valueSymbol:)
#(64 1 #valueSymbol:)
#(64 3 #contents2:)
#(64 3 #contents2:)
#(64 1 #valueSymbol:)
#(65 2 #method:)
#(65 3 #methodPrim:)
#(65 4 #methodTempsPrim:)
#(68 1 #first:)
#(68 1 #first:)
#(68 1 #first:)
#(69 1 #reduceFor:)
#(70 0 #reduceFor:)
#(70 2 #reduceFor:)
#(70 2 #reduceFor:)
#(70 2 #reduceFor:)
#(70 2 #reduceFor:)
#(70 2 #reduceFor:)
#(70 2 #reduceFor:)
#(70 2 #reduceFor:)
#(70 2 #reduceFor:)
#(70 2 #reduceFor:)
#(70 2 #reduceFor:)
)! !

!ByteSurgeonParser methodsFor: 'generated-tables' stamp: 'md 6/11/2005 14:51'!
transitionTable
	^#(
#(3 17 23 21 24 25 26 29 49 33 60 37 65)
#(3 41 1 45 3 49 4 53 8 57 9 61 10 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 50 157 51 161 52 165 58 169 61 6 66)
#(3 17 23 21 24 25 26 29 49 173 60)
#(2 290 1 3 4 6 8 9 10 11 12 14 15 16 18 20 21 22 23 31 66)
#(3 101 23 177 58)
#(3 101 23 181 58)
#(3 298 1 298 3 298 4 298 6 298 8 298 9 298 10 298 11 298 12 298 14 298 15 298 16 298 18 298 20 298 21 298 22 298 23 185 24 298 31 298 66)
#(3 41 1 45 3 49 4 189 6 53 8 57 9 61 10 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 193 47 149 48 153 50 157 51 161 52 165 58 197 59 201 61 6 66)
#(2 0 66)
#(3 41 1 6 2 45 3 49 4 205 5 53 8 57 9 61 10 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 39 209 40 121 41 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 50 157 51 161 52 165 58 213 61)
#(2 217 12)
#(3 22 4 22 23 221 36)
#(3 41 1 45 3 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 225 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58)
#(3 41 1 45 3 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 229 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58)
#(2 186 1 2 3 6 8 9 11 12 14 15 16 18 20 21 22 23 31 66)
#(2 126 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(3 233 1 237 9 241 22 245 23 249 24 253 25 257 26 261 28)
#(2 122 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 178 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 118 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(3 41 1 45 3 53 8 57 9 65 11 69 12 73 14 77 15 81 16 85 18 6 19 89 20 93 21 97 22 101 23 105 31 265 35 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58)
#(2 130 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 134 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 142 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 282 1 2 3 4 5 6 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 27 31 32 66)
#(2 138 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 302 2 66)
#(3 38 2 38 19 269 32 273 38 38 66)
#(2 30 2 19 32 66)
#(2 102 2 13 17 19 23 24 26 32 66)
#(2 46 2 13 19 32 66)
#(3 50 2 50 13 277 17 50 19 50 32 50 66)
#(3 54 2 54 13 54 19 281 23 285 24 289 26 54 32 293 53 297 54 301 55 54 66)
#(2 98 2 13 17 19 23 24 26 32 66)
#(2 106 2 13 17 19 23 24 26 32 66)
#(3 41 1 6 2 45 3 53 8 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 305 35 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58 6 66)
#(2 86 2 13 17 19 32 66)
#(2 194 2 13 17 19 32 66)
#(3 198 2 198 13 198 17 198 19 285 24 289 26 198 32 309 54 313 55 198 66)
#(3 202 2 202 13 202 17 202 19 281 23 285 24 289 26 202 32 317 53 321 54 325 55 202 66)
#(3 110 2 110 13 110 19 110 23 110 24 110 26 329 27 110 32 110 66)
#(2 0 66)
#(2 0 66)
#(2 206 1 3 4 6 8 9 10 11 12 14 15 16 18 20 21 22 23 24 31 66)
#(2 294 1 3 4 6 8 9 10 11 12 14 15 16 18 20 21 22 23 31 66)
#(3 101 23 333 58)
#(3 390 3 390 7 390 9 390 11 390 12 390 13 390 14 390 15 390 16 390 17 390 18 390 19 390 20 390 21 390 22 390 23 390 24 390 26 390 31 390 32 337 70)
#(3 41 1 45 3 189 6 53 8 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 305 35 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58 341 59 6 66)
#(3 41 1 45 3 49 4 53 8 57 9 61 10 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 50 157 51 161 52 165 58 345 61 6 66)
#(2 362 66)
#(3 101 23 349 58)
#(3 353 2 357 4 361 5 365 10)
#(2 369 2)
#(2 373 23)
#(3 377 4 101 23 381 58)
#(3 38 2 38 19 385 32 389 38 38 66)
#(2 393 13)
#(3 310 2 310 20 397 62)
#(3 318 1 318 3 318 9 318 11 318 12 318 13 318 14 318 15 318 16 318 20 318 21 318 22 318 23 318 24 318 25 318 26 318 28 318 31 318 34 401 63)
#(2 146 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 150 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 158 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 162 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 154 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 166 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 405 19)
#(3 41 1 42 2 45 3 409 8 57 9 65 11 69 12 73 14 77 15 81 16 85 18 42 19 89 20 93 21 97 22 101 23 105 31 413 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58 42 66)
#(2 10 2 19 66)
#(3 281 23 285 24 289 26 417 53 421 54 425 55 429 68)
#(2 246 2 13 17 19 23 24 26 32 66)
#(3 41 1 45 3 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 121 41 433 44 137 45 141 46 437 51 441 52 445 56 449 58)
#(3 41 1 45 3 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 121 41 453 44 137 45 141 46 457 52 461 57 449 58)
#(2 242 2 13 17 19 23 24 26 32 66)
#(2 234 2 13 17 19 24 26 32 66)
#(3 222 2 222 13 222 17 222 19 465 24 222 32 222 66)
#(2 306 2 66)
#(2 226 2 13 17 19 24 26 32 66)
#(3 214 2 214 13 214 17 214 19 465 24 214 32 214 66)
#(2 238 2 13 17 19 23 24 26 32 66)
#(2 230 2 13 17 19 24 26 32 66)
#(3 218 2 218 13 218 17 218 19 465 24 218 32 218 66)
#(3 41 1 45 3 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 469 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58)
#(2 210 1 3 4 6 8 9 10 11 12 14 15 16 18 20 21 22 23 24 31 66)
#(3 45 3 473 7 477 9 65 11 69 12 481 13 73 14 77 15 81 16 485 17 489 18 493 19 89 20 93 21 97 22 497 23 501 24 505 26 105 31 509 32 513 46)
#(3 41 1 45 3 53 8 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 517 35 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58 6 66)
#(2 366 66)
#(2 58 2 4 5 10)
#(2 74 2 13 17 19 23 24 26 32 66)
#(3 41 1 6 2 45 3 49 4 53 8 57 9 61 10 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 50 157 51 161 52 165 58 521 61)
#(3 101 23 525 58)
#(3 22 4 22 23 529 36)
#(2 70 2 13 17 19 23 24 26 32 66)
#(2 533 7)
#(2 190 1 2 3 6 8 9 11 12 14 15 16 18 20 21 22 23 31 66)
#(2 26 4 23)
#(2 42 2 19 66)
#(2 18 2 19 66)
#(2 94 2 13 17 19 23 24 26 32 66)
#(3 537 2 541 20)
#(3 545 1 45 3 549 9 65 11 69 12 553 13 73 14 77 15 81 16 89 20 93 21 97 22 557 23 561 24 565 25 569 26 573 28 105 31 577 34 581 46 585 64)
#(2 114 2 13 17 19 23 24 26 32 66)
#(3 41 1 45 3 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 589 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58)
#(2 34 2 19 32 66)
#(2 374 2 13 17 19 32 66)
#(2 378 2 13 17 19 32 66)
#(3 382 2 382 13 382 17 382 19 465 24 382 32 382 66)
#(2 90 2 13 17 19 32 66)
#(3 270 2 270 13 270 17 270 19 281 23 270 24 289 26 270 32 293 53 297 54 270 66)
#(3 262 2 262 13 262 17 262 19 262 24 289 26 262 32 309 54 262 66)
#(3 266 2 266 13 266 17 266 19 281 23 266 24 289 26 266 32 317 53 321 54 266 66)
#(2 254 2 13 17 19 24 32 66)
#(2 110 2 13 17 19 23 24 26 32 66)
#(3 278 2 278 13 278 17 278 19 281 23 278 24 278 26 278 32 293 53 278 66)
#(3 274 2 274 13 274 17 274 19 281 23 274 24 274 26 274 32 317 53 274 66)
#(2 250 2 13 17 19 24 26 32 66)
#(3 41 1 45 3 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 121 41 433 44 137 45 141 46 437 51 441 52 593 56 449 58)
#(2 82 2 13 19 32 66)
#(2 286 1 3 4 8 9 10 11 12 14 15 16 18 20 21 22 23 31 66)
#(2 402 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 406 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 418 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 410 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 414 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 426 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 394 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 430 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 422 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 398 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 26 31 32)
#(2 370 66)
#(2 597 2)
#(2 62 2 4 5 10)
#(3 601 4 101 23 381 58)
#(2 182 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 170 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 314 2 20)
#(3 310 2 310 20 605 62)
#(3 318 1 318 3 318 9 318 11 318 12 318 13 318 14 318 15 318 16 318 20 318 21 318 22 318 23 318 24 318 25 318 26 318 28 318 31 318 34 609 63)
#(2 174 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 28 31 32 34 66)
#(2 330 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(2 338 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(2 342 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(2 334 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(2 346 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(2 358 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(2 326 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(2 322 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(3 38 2 38 19 385 32 613 38 38 66)
#(2 258 2 13 17 19 24 32 66)
#(2 66 2 13 17 19 23 24 26 32 66)
#(3 41 1 6 2 45 3 53 8 57 9 65 11 69 12 73 14 77 15 81 16 85 18 89 20 93 21 97 22 101 23 105 31 617 35 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 165 58)
#(3 621 2 541 20)
#(3 545 1 45 3 549 9 65 11 69 12 625 13 73 14 77 15 81 16 89 20 93 21 97 22 557 23 561 24 565 25 569 26 573 28 105 31 577 34 581 46 585 64)
#(2 14 2 19 66)
#(2 629 2)
#(2 354 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(2 350 1 3 9 11 12 13 14 15 16 20 21 22 23 24 25 26 28 31 34)
#(2 78 2 13 17 19 23 24 26 32 66)
)! !

SqueakScanner subclass: #ByteSurgeonScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!ByteSurgeonScanner commentStamp: '<historical>' prior: 0!
Modified Scanner for Bytesurgeon: This adds support for <ARGS: aNumber> access to unamed arguments!

!ByteSurgeonScanner class methodsFor: 'generated-initialization' stamp: 'md 6/11/2005 14:51'!
initializeKeywordMap
	keywordMap _ Dictionary new.
	#(#(23 'false' 14) #(23 'nil' 11) #(23 'true' 16)) do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^ keywordMap! !

!ByteSurgeonScanner class methodsFor: 'generated-comments' stamp: 'md 6/11/2005 14:51'!
scannerDefinitionComment

	"<decimalNumber>:	[0-9]+ (\. [0-9]+)? ;
<radixNumber>:		[0-9]+ r [0-9A-Z]+ (\. [0-9A-Z]+)? ;
<scaledNumber>:		<decimalNumber> s [0-9]+ ;
<exponentNumber>:	(<decimalNumber> | <radixNumber>) e \-? [0-9]+ ;
<number>:			<decimalNumber> | <radixNumber> | <exponentNumber> | <scaledNumber> ;
<negativeNumber>:	\- <number> ;
<string>:				\'  [^\']* \' (\' [^\']* \')* ;
<name>:				[a-zA-Z] [a-zA-Z0-9]* ;
<keyword>:			<name> \: ;
<multikeyword>:		<name> \: (<name> \: )+ ;
<binarySymbol>:		[\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,]* ;
<assignment>:		\: \= | \_ ;
<alternateKeyword>:	\: <name> \: (<name> \:)* ;
<whitespace>:		\s+ ;
<comment>:			\"" [^\""]* \"" ;
<character>:			\$ . ;
<period>:				\. ;
<variableAssignment>:	<name> \: \= ;

<anyChar>:			. ; # For VW literal arrays that handle #(;) -> #(#';')
"! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 6/11/2005 14:51'!
binarySymbolId
	^26! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 6/11/2005 14:51'!
emptySymbolTokenId
	^66! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 6/11/2005 14:51'!
errorTokenId
	^67! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 6/11/2005 14:51'!
nameId
	^23! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 6/11/2005 14:51'!
negativeNumberId
	^21! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 6/11/2005 14:51'!
numberId
	^20! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 6/11/2005 14:51'!
periodId
	^32! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan1
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter == $- ifTrue: [^ self scan2].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan10
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			currentCharacter == $e ifTrue: [^ self scan1].
			currentCharacter == $s ifTrue: [^ self scan2].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan11
	self recordMatch: #(24).
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan7].
	currentCharacter == $= 
		ifTrue: [^ self recordAndReportMatch: #variableAssignment].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan2
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan3
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(21).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan4
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(21).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter == $- ifTrue: [^ self scan3].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan5
	self recordMatch: #(22).
	self step.
	currentCharacter == $' ifTrue: [^ self scan6].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan6
	
	[self step.
	currentCharacter ~~ $'] whileTrue.
	^ self scan5! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan7
	
	[self step.
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(25).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan7].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan8
	
	[self step.
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(28).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan8].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scan9
	self step.
	(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
					whileTrue.
			currentCharacter == $. 
				ifTrue: 
					[self step.
					(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
						ifTrue: 
							[
							[self recordMatch: #(20).
							self step.
							currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
									whileTrue.
							currentCharacter == $e ifTrue: [^ self scan1].
							^ self reportLastMatch].
					^ self reportLastMatch].
			currentCharacter == $e ifTrue: [^ self scan1].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 6/11/2005 14:51'!
scanForToken
	self step.
	(currentCharacter <= $ or: 
			[(currentCharacter between: $ and: $) 
				or: [currentCharacter == $` or: [currentCharacter >= $]]]) 
		ifTrue: [^ self recordAndReportMatch: #(34)].
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[self recordMatch: #(23 34).
				self step.
				(currentCharacter isDigit or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]) 
					ifTrue: 
						[
						[self recordMatch: #(23).
						self step.
						currentCharacter isDigit or: 
								[(currentCharacter between: $A and: $Z) 
									or: [currentCharacter between: $a and: $z]]] 
								whileTrue.
						currentCharacter == $: ifTrue: [^ self scan11].
						^ self reportLastMatch].
				currentCharacter == $: ifTrue: [^ self scan11].
				^ self reportLastMatch].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[currentCharacter == $= or: 
											[(currentCharacter between: $? and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			currentCharacter isSpecial 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter isDigit 
		ifTrue: 
			[self recordMatch: #(20 34).
			self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(20).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $. ifTrue: [^ self scan10].
					currentCharacter == $e ifTrue: [^ self scan1].
					currentCharacter == $r ifTrue: [^ self scan9].
					currentCharacter == $s ifTrue: [^ self scan2].
					^ self reportLastMatch].
			currentCharacter == $. ifTrue: [^ self scan10].
			currentCharacter == $e ifTrue: [^ self scan1].
			currentCharacter == $r ifTrue: [^ self scan9].
			currentCharacter == $s ifTrue: [^ self scan2].
			^ self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[self recordMatch: #whitespace.
			self step.
			(currentCharacter isSeparator or: [currentCharacter == $]) 
				ifTrue: 
					[
					[self recordMatch: #whitespace.
					self step.
					currentCharacter isSeparator or: [currentCharacter == $]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[self recordMatch: #(34).
			self step.
			currentCharacter ~~ $" 
				ifTrue: 
					[
					[self step.
					currentCharacter ~~ $"] whileTrue.
					^ self recordAndReportMatch: #comment].
			currentCharacter == $" ifTrue: [^ self recordAndReportMatch: #comment].
			^ self reportLastMatch].
	currentCharacter == $# 
		ifTrue: 
			[self recordMatch: #(12 34).
			self step.
			currentCharacter == $: ifTrue: [^ self recordAndReportMatch: #(15)].
			^ self reportLastMatch].
	currentCharacter == $$ 
		ifTrue: 
			[self recordMatch: #(34).
			self step.
			^ self recordAndReportMatch: #(31)].
	currentCharacter == $' 
		ifTrue: 
			[self recordMatch: #(34).
			self step.
			currentCharacter ~~ $' ifTrue: [^ self scan6].
			currentCharacter == $' ifTrue: [^ self scan5].
			^ self reportLastMatch].
	currentCharacter == $( ifTrue: [^ self recordAndReportMatch: #(9 34)].
	currentCharacter == $) ifTrue: [^ self recordAndReportMatch: #(13 34)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #binarySymbol.
			self step.
			currentCharacter isSpecial 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(21).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $. 
						ifTrue: 
							[self step.
							currentCharacter isDigit 
								ifTrue: 
									[
									[self recordMatch: #(21).
									self step.
									currentCharacter isDigit] 
											whileTrue.
									currentCharacter == $e ifTrue: [^ self scan4].
									currentCharacter == $s ifTrue: [^ self scan3].
									^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter == $e ifTrue: [^ self scan4].
					currentCharacter == $r 
						ifTrue: 
							[self step.
							(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
								ifTrue: 
									[
									[self recordMatch: #(21).
									self step.
									currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
											whileTrue.
									currentCharacter == $. 
										ifTrue: 
											[self step.
											(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
												ifTrue: 
													[
													[self recordMatch: #(21).
													self step.
													currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
															whileTrue.
													currentCharacter == $e ifTrue: [^ self scan4].
													^ self reportLastMatch].
											^ self reportLastMatch].
									currentCharacter == $e ifTrue: [^ self scan4].
									^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter == $s ifTrue: [^ self scan3].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter == $. ifTrue: [^ self recordAndReportMatch: #(32 34)].
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(5 34).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^ self scan8].
			currentCharacter == $= ifTrue: [^ self recordAndReportMatch: #(27)].
			^ self reportLastMatch].
	currentCharacter == $; ifTrue: [^ self recordAndReportMatch: #(17 34)].
	currentCharacter == $< 
		ifTrue: 
			[self recordMatch: #(6 26 34).
			self step.
			currentCharacter isSpecial 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			currentCharacter == $m 
				ifTrue: 
					[self step.
					currentCharacter == $e 
						ifTrue: 
							[self step.
							currentCharacter == $t 
								ifTrue: 
									[self step.
									currentCharacter == $a 
										ifTrue: 
											[self step.
											currentCharacter == $: ifTrue: [^ self recordAndReportMatch: #(3)].
											^ self reportLastMatch].
									^ self reportLastMatch].
							^ self reportLastMatch].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter == $> 
		ifTrue: 
			[self recordMatch: #(7 26 34).
			self step.
			currentCharacter isSpecial 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter == $[ ifTrue: [^ self recordAndReportMatch: #(1 34)].
	currentCharacter == $] ifTrue: [^ self recordAndReportMatch: #(2 34)].
	currentCharacter == $^ ifTrue: [^ self recordAndReportMatch: #(8 34)].
	currentCharacter == $_ ifTrue: [^ self recordAndReportMatch: #(27 34)].
	currentCharacter == ${ ifTrue: [^ self recordAndReportMatch: #(18 34)].
	currentCharacter == $| 
		ifTrue: 
			[self recordMatch: #(4 26 34).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $-) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			currentCharacter == $| 
				ifTrue: 
					[self recordMatch: #(10 26).
					self step.
					currentCharacter isSpecial 
						ifTrue: 
							[
							[self recordMatch: #binarySymbol.
							self step.
							currentCharacter isSpecial] 
									whileTrue.
							^ self reportLastMatch].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter == $} ifTrue: [^ self recordAndReportMatch: #(19 34)].
	^ self reportLastMatch! !

!BlockContext methodsFor: '*bytesurgeon' stamp: 'md 2/24/2005 12:09'!
ir

	self flag: #fixme.
	self halt.
	"| end |
	end _ (self method at: startpc - 2)
				\\ 16 - 4 * 256
				+ (self method at: startpc - 1) + startpc - 1.
	^BytecodeDecompiler decompileBlockFrom: startpc to: end."! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 7/10/2005 09:47'!
balanceStackPOP: instr
	instr isEmpty ifTrue: [^self].
	"instr last addInstructionsAfter: {IRInstruction popTop}."! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 22:16'!
balanceStack: instr
	! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/24/2005 10:24'!
bsPatchCm
	| bc | 
	bc := IRTranslator new
		trailer: compiledMethod trailer;
		interpret: self;
		bytecodes.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:03'!
insertAfter: aString
	self insertAfter: aString with: nil.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:03'!
insertAfter: aString with: aDict
	| inliner |
	inliner :=  IRInlinerMethod on: self with: aDict.
	inliner insertAfter: aString.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:04'!
insertBefore: aString
	self insertBefore: aString with: nil.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:04'!
insertBefore: aString with: aDict
	| inliner |
	inliner :=  IRInlinerMethod on: self with: aDict.
	inliner insertBefore: aString.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'dr 4/5/2005 20:12'!
originalMaxTemp
	^self compiledMethod numTmpVars
	! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:04'!
replace: aString
	self replace: aString with: nil.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:04'!
replace: aString with: aDict
	| inliner |
	inliner :=  IRInlinerMethod on: self with: aDict.
	inliner replace: aString.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 14:12'!
selector
	selector ifNil: [selector := compiledMethod selector].
	^selector.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:38'!
tempVarNameForOffset: offset
	^compiledMethod tempVarNameForOffset: offset.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 13:44'!
updateSequenceNumbers
	IRNumberer on: self.! !

!IRSend methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 10:32'!
insertAfter: aString with: aDict
	| inliner |
	inliner :=  IRInlinerSend on: self with: aDict.
	inliner insertAfter: aString.! !

!IRSend methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 10:32'!
insertBefore: aString with: aDict
	| inliner |
	inliner :=  IRInlinerSend on: self with: aDict.
	inliner insertBefore: aString.! !

!IRSend methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 10:32'!
replace: aString with: aDict
	| inliner |
	inliner :=  IRInlinerSend on: self with: aDict.
	inliner replace: aString.! !

ASTTranslator subclass: #BSASTTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!BSASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'md 6/29/2005 12:19'!
acceptDoItNode: aDoItNode 
	| scope |

	methodBuilder numRargs: 1.
	methodBuilder addTemps: #(self 1 2 3 4 5 6 7 8 9 10 11 12 13
							14 15 16 17 18 19 20 21 22 23).
	aDoItNode byteSurgeon: true.
	scope :=  aDoItNode scope.
	methodBuilder addTemps: scope tempVars.
	aDoItNode scope emitPrologue: methodBuilder.
	valueTranslator visitNode: aDoItNode body.
	aDoItNode body lastIsReturn ifFalse: [
		methodBuilder returnTop].! !

!BSASTTranslator methodsFor: 'initialize' stamp: 'md 2/25/2005 12:27'!
initialize

	methodBuilder := IRBuilder new.
	effectTranslator := self as: ASTTranslatorForEffect.
	valueTranslator := self as: BSASTTranslatorForValue.
	effectTranslator instVarNamed: #effectTranslator put: effectTranslator.
	effectTranslator instVarNamed: #valueTranslator put: valueTranslator.
	valueTranslator instVarNamed: #valueTranslator put: valueTranslator.
! !

!BSASTTranslator methodsFor: 'initialize' stamp: 'md 6/16/2005 13:57'!
inliner: anInliner
	valueTranslator inliner: anInliner.! !

!IRTempAccess methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:56'!
varname
	name ifNil: [name := self method compiledMethod tempVarNameForOffset: self offset].
	^name.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:08'!
instrumentAll: aBlockCollection
	super instrumentAll: aBlockCollection.
	self class instrumentAll: aBlockCollection.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:05'!
instrumentConstant:  aBlock
	super instrumentConstant:  aBlock.
	self class instrumentConstant: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:05'!
instrumentInstVarAccess:  aBlock
	super instrumentInstVarAccess:  aBlock.
	self class instrumentInstVarAccess: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:05'!
instrumentInstVarRead:  aBlock
	super instrumentInstVarRead:  aBlock.
	self class instrumentInstVarRead: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:05'!
instrumentInstVarStore:  aBlock
	super instrumentInstVarStore:  aBlock.
	self class instrumentInstVarStore: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:06'!
instrumentSend:  aBlock
	super instrumentSend:  aBlock.
	self class instrumentSend: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:06'!
instrumentTempAccess:  aBlock
	super instrumentTempAccess:  aBlock.
	self class instrumentTempAccess: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:06'!
instrumentTempRead:  aBlock
	super instrumentTempRead:  aBlock.
	self class instrumentTempRead: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:06'!
instrumentTempStore:  aBlock
	super instrumentTempStore:  aBlock.
	self class instrumentTempStore: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 6/29/2005 17:05'!
instrument: aBlock
	super instrument: aBlock.
	self class instrument: aBlock.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:45'!
bsTempNames
	"Answer an OrderedCollection of the names of the receiver's temporary 
	variables, which are strings."

	"unused temps at end are not included in method. On the other hand, extra temps such as to:do: loop limit are added to method"
	| tempNames n |
	tempNames := self methodNode tempNames.
	n := self numTemps.
	tempNames size = n ifTrue: [^ tempNames].
	tempNames size > n ifTrue: [^ tempNames first: n].
	tempNames size + 1 to: n do: [:i |
		tempNames := tempNames copyWith: 't' , i printString].
	^ tempNames! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:52'!
flagByteSurgeon
	self setProperty: #bytesurgeon toValue: true.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/10/2005 22:44'!
genAndReplaceMyselfWith: ir
	| new |
	new := ir compiledMethodWith: self trailer.
	new numTmpVars: self numTmpVars.			
	new flagByteSurgeon.
	self definitionClass addSelectorSilently: self selector withMethod: new. ! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/30/2005 14:15'!
insertAfter: aString
	self insertAfter: aString with: nil! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:25'!
insertAfter: aStringOrBlockOrCollection with: dict
	| ir |
	ir := self ir insertAfter: aStringOrBlockOrCollection with: dict.
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/30/2005 14:15'!
insertBefore: aString
	self insertBefore: aString with: nil.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/10/2005 09:23'!
insertBefore: before after: after
	
	| ir |
	ir := (self ir insertBefore: before) insertAfter: after.
	self genAndReplaceMyselfWith: ir.

	! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:25'!
insertBefore: aStringOrBlockOrCollection with: dict
	| ir |
	ir := self ir insertBefore: aStringOrBlockOrCollection with: dict.
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:25'!
instrumentAll: aBlockCollection
	| ir  |
	ir := self ir.
	(ir allInstructionsMatching: [:t | true]) do: [:instr | aBlockCollection do: [:block | block value: instr]].
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:49'!
instrumentConstant: aBlock
	self instrument: aBlock matching: [:instr | instr isConstant].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:19'!
instrumentInstVarAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarAccess].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:19'!
instrumentInstVarRead: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarRead].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 12:28'!
instrumentInstVarStore: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarStore].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:44'!
instrumentSend: aBlock
	self instrument: aBlock matching: [:instr | instr isSend].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:05'!
instrumentTempAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isTempAccess].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:43'!
instrumentTempRead: aBlock
	self instrument: aBlock matching: [:instr | instr isTempRead].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 12:28'!
instrumentTempStore: aBlock
	self instrument: aBlock matching: [:instr | instr isTempStore].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:42'!
instrument: aBlock
	self instrument: aBlock matching: [:instr | true].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:25'!
instrument: aBlock matching: aMatchBlock
	| ir  |
	ir := self ir.
	(ir allInstructionsMatching: aMatchBlock) do: aBlock.
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:30'!
isByteSurgeon
	^self valueOfProperty: #bytesurgeon ifAbsent: [false].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 14:12'!
methodNode
	^ self method homeMethodNodeDecompileClass: self definitionClass selector: self selector.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:53'!
numTmpVars
	"Answer number of temps of self. 
	This information is stored in the property #origTempNum
	Because this method does not read the byte code to count the number of temps. one always gets the original number
	of temps, even ByteSurgeon has added some tmps later on."

	self isByteSurgeon ifFalse: [^self numTemps].
	^self valueOfProperty: #origTempNum.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:53'!
numTmpVars: num
	self setProperty: #origTempNum toValue: num.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 14:12'!
recompile
	"recompile the method from source. Works only if who can find out the
      class/selector"
	
	self definitionClass recompile: self selector.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/30/2005 14:13'!
replace: aString
	self replace: aString with: nil.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:26'!
replace: aString with: dict
	| ir |
	ir := self ir replace: aString with: dict.
	self genAndReplaceMyselfWith: ir.! !

!RBDoItNode methodsFor: '*bytesurgeon' stamp: 'md 6/16/2005 13:58'!
generateIRForInlining: inliner

	^ ir := BSASTTranslator new
		inliner: inliner;
		visitNode: self;
		ir! !

ASTTranslatorForValue subclass: #BSASTTranslatorForValue
	instanceVariableNames: 'inliner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!BSASTTranslatorForValue methodsFor: 'visiting' stamp: 'md 6/23/2005 16:02'!
acceptByteSurgeonNode: aNode
	methodBuilder pushTemp: (inliner  getOffsetForName: aNode reify).! !

!BSASTTranslatorForValue methodsFor: 'accessing' stamp: 'md 6/16/2005 13:57'!
inliner: anInliner
	inliner := anInliner! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 11:49'!
insertAfter: aString with: aDict
	| inliner |
	inliner :=  IRInlinerAccess on: self with: aDict.
	inliner insertAfter: aString.! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 11:50'!
insertBefore: aString with: aDict
	| inliner |
	inliner :=  IRInlinerAccess on: self with: aDict.
	inliner insertBefore: aString.! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:08'!
offset
	^number! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:30'!
replaceAndStore: aString 
	self replaceAndStore: aString with: nil.! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:21'!
replaceAndStore: aString with: aDict
	| inliner |
	inliner :=  IRInlinerAccess on: self with: aDict.
	inliner replaceAndStore: aString.! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 11:50'!
replace: aString with: aDict
	| inliner |
	inliner :=  IRInlinerAccess on: self with: aDict.
	inliner replace: aString.! !

!MethodContext methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:52'!
tempVarNameForOffset: num
	^self tempNames at: num.! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 7/7/2005 16:47'!
instrumentAll: aBlockCollection
	self methodDict values copy do: [ :method |
		method instrumentAll: aBlockCollection
	].
! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:48'!
instrumentConstant: aBlock
	self instrument: aBlock matching: [:instr | instr isConstant].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:14'!
instrumentInstVarAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarAccess].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:14'!
instrumentInstVarRead: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarRead].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 12:05'!
instrumentInstVarStore: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarStore].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:48'!
instrumentSend: aBlock
	self instrument: aBlock matching: [:instr | instr isSend].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:04'!
instrumentTempAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isTempAccess].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:48'!
instrumentTempRead: aBlock
	self instrument: aBlock matching: [:instr | instr isTempRead].
! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 12:06'!
instrumentTempStore: aBlock
	self instrument: aBlock matching: [:instr | instr isTempStore].
! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:47'!
instrument: aBlock
	self instrument: aBlock matching: [:instr | true].! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 7/7/2005 16:40'!
instrument: aBlock matching: aMatchBlock
	self methodDict values copy do: [ :method |
		method instrument: aBlock matching: aMatchBlock.
	].
! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 15:03'!
instVarNameForOffset: offset
	^self instVarNames at: offset.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 22:16'!
balanceStackPOP: instr
	instr last isGoto 
		ifFalse: [instr last addInstructionsAfter: {IRInstruction popTop}]
		ifTrue: [instr last addInstructionsBefore: {IRInstruction popTop}].! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 22:16'!
balanceStack: instr! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'dr 4/7/2005 20:08'!
evaluate: aBlock
	^aBlock value: self! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:20'!
insertAfter: aString
	self insertAfter: aString with: nil.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:21'!
insertAfter: aString with: aDict
	| inliner |
	inliner :=  IRInliner on: self with: aDict.
	inliner insertAfter: aString.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 22:42'!
insertBefore: aString
	self insertBefore: aString with: nil. ! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:21'!
insertBefore: aString with: aDict
	| inliner |
	inliner :=  IRInliner on: self with: aDict.
	inliner insertBefore: aString.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:21'!
replace: aString
	self replace: aString with: nil.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 12:21'!
replace: aString with: aDict
	| inliner |
	inliner :=  IRInliner on: self with: aDict.
	inliner replace: aString.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 12:26'!
selector
	^self method selector.! !
